- fix /plc/data declaration
[myplc.git] / build.sh
index d8e946f..f0243e5 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -18,7 +18,7 @@ if [ -d ../build ] ; then
     PATH=$PATH:../build
     srcdir=..
 else
-    echo "Error: Could not find sources in either . or .."
+    echo "Error: Could not find $(cd .. && pwd -P)/build/"
     exit 1
 fi
 
@@ -31,9 +31,6 @@ config=plc_config.xml
 releasever=2
 basearch=i386
 
-# Data directory base
-usr_share=/usr/share
-
 # Initial size of the image
 size=1000000000
 
@@ -43,14 +40,13 @@ usage()
     echo "     -c file         PLC configuration file (default: $config)"
     echo "     -r release      Fedora release number (default: $releasever)"
     echo "     -a arch         Fedora architecture (default: $basearch)"
-    echo "     -d datadir      Data directory base (default: $usr_share)"
     echo "     -s size         Approximate size of the installation (default: $size)"
     echo "     -h              This message"
     exit 1
 }
 
 # Get options
-while getopts "c:r:a:d:s:h" opt ; do
+while getopts "c:r:a:s:h" opt ; do
     case $opt in
        c)
            config=$OPTARG
@@ -61,9 +57,6 @@ while getopts "c:r:a:d:s:h" opt ; do
        a)
            basearch=$OPTARG
            ;;
-       d)
-           usr_share=$OPTARG
-           ;;
        s)
            size=$OPTARG
            ;;
@@ -76,8 +69,8 @@ done
 # Do not tolerate errors
 set -e
 
-root=fc$releasever
-data=data$releasever
+root=root
+data=data
 
 if [ ! -f $root.img ] ; then
     bs=4096
@@ -103,7 +96,7 @@ done < <(./plc-config --packages $config)
 mkfedora -v -r $releasever -a $basearch $packages $root
 
 # Disable all services in reference image
-chroot $vroot sh -c "/sbin/chkconfig --list | awk '{ print \$1 }' | xargs -i /sbin/chkconfig {} off"
+chroot $root sh -c "/sbin/chkconfig --list | awk '{ print \$1 }' | xargs -i /sbin/chkconfig {} off"
 
 # FC2 minilogd starts up during shutdown and makes unmounting
 # impossible. Just get rid of it.
@@ -225,24 +218,18 @@ fi
 
 # Write sysconfig
 cat >plc.sysconfig <<EOF
-PLC_ROOT=$usr_share/plc/$root
-PLC_DATA=$usr_share/plc/$data
+PLC_ROOT=/plc/$root
+PLC_DATA=/plc/$data
 #PLC_OPTIONS="-v"
 EOF
 
-# Install node RPMs
+# Initialize node RPMs directory. The PlanetLab-Bootstrap.tar.bz2
+# tarball already contains all of the node RPMs pre-installed. Only
+# updates or optional packages should be placed in this directory.
 if [ -n "$RPM_BUILD_DIR" ] ; then
-    echo "* Installing node RPMs"
+    echo "* Initializing node RPMs directory"
     RPM_RPMS_DIR=$(cd $(dirname $RPM_BUILD_DIR)/RPMS && pwd -P)
     mkdir -p $data/var/www/html/install-rpms/planetlab
-    # Exclude ourself (e.g., if rebuilding), the bootcd and
-    # bootmanager builds, and debuginfo RPMs.
-    rsync -a \
-       --exclude='myplc-*' \
-       --exclude='bootcd-*' --exclude='bootmanager-*' \
-       --exclude='*-debuginfo-*' \
-       $(find $RPM_RPMS_DIR -type f -and -name '*.rpm') \
-       $data/var/www/html/install-rpms/planetlab/
     if [ -f $RPM_RPMS_DIR/yumgroups.xml ] ; then
        install -D -m 644 $RPM_RPMS_DIR/yumgroups.xml \
            $data/var/www/html/install-rpms/planetlab/yumgroups.xml
@@ -281,6 +268,11 @@ RETVAL=$?
 # Restore default configuration before shutting down
 install -D -m 644 $config $data/etc/planetlab/plc_config.xml
 
+# Remove ISO and USB images, which take up >100MB but only take a
+# couple of seconds to generate at first boot.
+rm -f $data/var/www/html/download/*.{iso,usb}
+install -D -m 644 $config $data/etc/planetlab/plc_config.xml
+
 ./host.init stop
 RETVAL=$(($RETVAL+$?))